/* $Id: PassswordEncoder.java,v 1.1 2007/12/10 06:19:34 nito Exp $
 *
 * Copyright (c)ARGO 21, Corporation. 2007.  All rights reserved.
 */
package jp.co.argo21.nautica.tool.pwg;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * Nautica Workflow用パスワードエンコーダ。
 *
 * @author  nito(Argo 21, Corp.)
 * @version $Revision: 1.1 $
 * @since   Nautica Workflow 1.0
 */
public class PassswordEncoder
{
	/**
	 * 引数に渡された情報から、エンコード済み文字列を生成して返す。
	 * アルゴリズムはSHAまたはMD5を利用する。(Sun JDKでは標準提供。他社製は要確認。)
	 * 
	 * <ul>
	 * <li>[Security provider] SUN</li>
	 * <li>[Algorithm] SHA</li>
	 * <li>[Algorithm] MD5</li>
	 * </ul>
	 *
	 * @param uid ユーザID
	 * @param passwd パスワード
	 * @param algorithm アルゴリズム
	 * @return エンコード済み文字列
	 */
	public static String encode(String uid, String passwd, String algorithm)
	{
		MessageDigest md = null;
		try {
			md = MessageDigest.getInstance(algorithm);
		} catch (NoSuchAlgorithmException ex) {
		}

		if (md != null) {
			md.update(uid.getBytes());
			md.update(passwd.getBytes());
			byte[] digest = md.digest();
			return Base64Encoder.encode(digest);
		} else {
			return algorithm + " is not exist.";
		}
	}
}
