/* $Id: SimplePWG.java,v 1.3 2007/12/10 06:33:14 nito Exp $
 *
 * Copyright (c)ARGO 21, Corporation. 2007.  All rights reserved.
 */
package jp.co.argo21.nautica.tool.pwg;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

import javax.swing.BorderFactory;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

public class SimplePWG extends JFrame
{
	private static final long serialVersionUID = 1L;

	private static final String[] MD_ALGORITHM = { "MD2", "MD5", "SHA", "SHA-256", "SHA-384", "SHA-512" };

	private JTextField user;
	private JPasswordField passwd;
	private JComboBox algorithm;
	private JTextField encoded;
	
	public SimplePWG()
	{
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Dimension screen = toolkit.getScreenSize();
		int sw = screen.width;
		int sh = screen.height;
		
		setResizable(false);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setTitle("Simple password generator");
		setContentPane(createView());
		pack();

		Dimension size = getSize();
		int fw = (int)size.width;
		int fh = (int)size.height;
		setLocation((sw - fw) / 2, (sh - fh) / 2);
	}
	
	private Container createView()
	{
		JPanel panel = new JPanel();
		panel.setPreferredSize(new Dimension(400, 300));
		panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		panel.setBackground(Color.LIGHT_GRAY);
		panel.setLayout(new GridLayout(0, 1));

		JLabel al = new JLabel("Algorithm");
		panel.add(al);
		algorithm = new JComboBox(new DefaultComboBoxModel(MD_ALGORITHM));
		algorithm.setSelectedIndex(2);
		panel.add(algorithm);

		JLabel ul = new JLabel("User ID");
		panel.add(ul);
		user = new JTextField();
		panel.add(user);

		JLabel pl = new JLabel("Password");
		panel.add(pl);
		passwd = new JPasswordField();
		panel.add(passwd);

		JLabel bl = new JLabel();
		panel.add(bl);
		JButton button = new JButton("Generate");
		button.setForeground(Color.WHITE);
		button.setBackground(Color.GRAY);
		button.addActionListener(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					String u = user.getText();
					String p = new String(passwd.getPassword());
					String a = (String)algorithm.getSelectedItem();
					encoded.setText(PassswordEncoder.encode(u, p, a));
				}
			}
		);
		JPanel bpanel = new JPanel();
		bpanel.setOpaque(false);
		bpanel.setLayout(new GridLayout(0, 1));
		bpanel.setBorder(BorderFactory.createEmptyBorder(0, 250, 0, 0));
		bpanel.add(button);
		panel.add(bpanel);

		JLabel el = new JLabel("Encoded string");
		panel.add(el);
		encoded = new JTextField();
		encoded.setEditable(false);
		encoded.setBackground(Color.YELLOW);
		panel.add(encoded);

		return panel;
	}

	public static void main(String[] args)
	{
		SimplePWG generator = new SimplePWG();
		generator.setVisible(true);
	}
}
